%%% Filename : f_kernl.pl
%%% Date     : 04.02.2013
%%% Contents : main method to start the program
%%% Author   : Lara Katharina Spendier <lara@logic.at>

:- use_module(library(time)).
:- ['f_operators.pl'].
:- ['f_listfunctions.pl'].
:- ['f_checkclass.pl'].
:- ['f_structural.pl'].
:- ['f_completion.pl'].
:- ['f_printcmd.pl'].
:- ['f_grammar.pl'].
:- ['f_tex.pl'].
:- ['f_frame2rule.pl'].

compute :-
		read(Frame),
		(\+ frames2tex(Frame,_,[]) ->
		handle("1")
		; 
		isCorrectFormula(Frame, CF),
		(CF = 0 ->
		  handle("1")
		; catch(
		  call_with_time_limit(1, startComputation(Frame, 0)),
                  Exception,                     
                  handle(Exception))
		)).

computeweb(Frame) :-
		(\+ frames2tex(Frame,_,[]) ->
		handle("1")
		; 
		isCorrectFormula(Frame, CF),
		(CF = 0 ->
		  handle("1")
		; catch(
		  call_with_time_limit(1, startComputation(Frame, 1)),
                  Exception,                     
                  handle(Exception))
		)),
		halt.

handle(_) :-
		texOut(_,_,100),
		writef('\n\nThe frame condition you provided was not computable.').


